<!DOCTYPE html>
<html>
<head>
	<title>Welcome To The Cold</title>

	<link rel="stylesheet" href="/static/font/mononoki/regular/font.css">
	<link rel="stylesheet" href="/static/stylesheet/normalize.css">
	<link rel="stylesheet" href="/static/stylesheet/base.css">

	<style>
		html,body,main,div,section,article,header,footer { margin:0; padding:0; box-sizing: border-box; }
		body { font-family: 'mononoki'; font-size: 16px; }
		main { padding: 10px; }
		details { margin: 10px 0; cursor: pointer; }
		details summary { margin-bottom: 5px; }
		details div { padding-left: 15px; cursor: unset !important; }
		details div p { padding: 0; margin: 0; font-style: italic; }
		details div p input { display: inline-block; width: 15px; height: 15px;}


		label,input,select { width: 100%; box-sizing: border-box; display: inline-block; 
												 padding: 5px; }
		input,select,textarea { background-color: white; border: 1px solid lightgrey; }
		form { width: 100%; box-sizing: border-box; }
		form label, form input { width: 100%; box-sizing: border-box; display: block; }
		label + input, label + select, label + textarea { margin-top: 5px; margin-bottom: 15px; }
		textarea { width: 100%; box-sizing: border-box; display: block; padding: 5px; }
		button { width: 100%; box-sizing: border-box; display: block; background-color: black; 
						 color: white; padding: 5px; border: 1px solid lightgrey; cursor: pointer; }
		button:hover { border: 1px solid tomato; }		
		button[type="submit"] { margin-top: 15px; }

		section.grid { 
			display: grid;
			grid-gap: 10px;
			grid-template-columns: repeat(4,auto);
			grid-template-rows: auto;
		}

		article { background-color: lightslategrey; }

		section.grid article.card { max-width: 300px; max-height: 300px; }
		
		article.card img { width: 100%; }

		article.widget { margin: 15px 0; background-color: lightgrey; padding: 10px; }


		code.z-unknown { display: block; width: 100%; opacity: 0.8; }

		button,label { text-transform: uppercase; }

		div.z-multiple { display: flex; }
		div.z-multiple * { margin-right: 5px; }
		div.z-multiple *:last-child { margin-right: 0; }
		div.z-multiple button[type="button"] { width: 30px; }
		
		ol.keywords, ol.keyvalues { list-style: none; padding: 0; margin: 0; }
		ol.keywords li, ol.keyvalues li { display: inline-block; margin: 1px; background-color: white; padding: 5px 15px; color: black; }
		ol.keywords li:first-of-type, ol.keyvalues li:first-of-type { margin-left: 0; }
		

	</style>

</head>
<body>
<main>

	<section>
	
		<article class="widget">
			<form action="/api/mock" method="post" data-xhr="yes" data-xhr-method="put">
				<div data-widget="first-last" data-firstname="Alice" data-lastname="Wonder"></div>

				<label>This is a label</label>
				<input data-reset="yes" type="text" name="some" value="orginal text" placeholder="this is some text">
				<button type="submit">update</button>	
			</form>
		</article>

		<article class="widget"><div data-widget="example"></div></article>

		<article class="widget"><div data-widget="bad-example"></div></article>


		<article>
			<ol class="keywords">
				<li>one</li>
				<li>two</li>
				<li>three</li>
				<li>four</li>
				<li>five</li>
			</ol>

			<ol class="keyvalues">
				<li>one=1</li>
				<li>two=2</li>
				<li>three=3</li>
				<li>four=4</li>
				<li>five=5</li>
			</ol>
		<article>
	</section>

	<canvas id="dataflow"></canvas>

</main>
<script>
document.addEventListener('DOMContentLoaded',function() {
	
	_.map(document.querySelectorAll("article.widget"),function(k) {
		m.mount(k,z.consume(k));
	});

	/* attempt to build dataflow engine */
	var engine = dataflow.engine("test").setPorts("a","b","c","d").setArc("a","b").setArc("c","d").setNode({name:"test"},"b","c");
	engine.setPortsInput("b").setPortsOutput("c")


	console.log("dataflow.render ",dataflow.render(engine,"dataflow"));

	

});
</script>


<template id="widget:example">
	<form>
		<label>This is some text</label>
		<input type="text" name="something" value="already has text" placeholder="this is some text">
		<label>This is a select</label>
		<select name="select" value="two">
			<option value="one">One</option>
			<option value="two">Two</option>
			<option value="three">Three</option>
		</select>
		<label>This is a text area</label>
		<textarea name="textarea">this is a text area</textarea>

		<button type="submit">update</button>
	</form>
</template>

<template id="widget:first-last">
	<label>First name</label>
	<input type="text" name="firstname" required>

	<label>Last name</label>
	<input type="text" name="lastname" required>
</template>




<script src="/static/javascript/mithril.js"></script>
<script src="/static/javascript/mithril-stream.js"></script>
<script src="/static/javascript/underscore.js"></script>
<script src="/static/javascript/zed.js"></script>
<script src="/static/javascript/dataflow.js"></script>

</body>
</html>
